#![feature(iter_intersperse)]

use std::io::Write;

use clap::Parser;

/// Utility command to output information
#[derive(Parser, Debug)]
#[command(version, about, long_about = None)]
struct Args {
	/// End each output line with NUL instead of newline
	#[arg(short='0', long)]
	null: bool,
}

fn main() {
	let args = Args::parse();

	let mut list: Vec<String> = vec![];
	for (k, v) in std::env::vars() {
		list.push(format!("{k}={v}"));
	}

	let mut data: String;

	if args.null {
		data = list.join("\0");
		data.push('\0');
	} else {
		data = list.join("\n");
		data.push('\n');
	}

	let mut out = std::io::stdout();

	match out.write_all(data.as_bytes()) {
		Err(e) => {
			eprintln!("Failed to write to stdout: {e}");
			std::process::exit(1);
		},
		Ok(()) => ()
	};
}